<template>
    <section>
        <div class="container" >
            <div class="row">
                <div class="shadow col-12 mt-4 p-3 mb-5 bg-white rounded">
                    <div class="float-left">
                        <a href="javascript:window.history.go(-1);"><i class="material-icons">arrow_back_ios</i> Regresar</a>
                    </div>
                    <h2 class="text-center">Asignación de Grupos</h2>
                </div>
            </div>
            <div class="row m-10">
                <div class="col-md-6">
                    <div class="card text-center">
                        <div class="card-header">
                            <h4><strong>Grupos</strong></h4>
                        </div>
                        <div class="card-body">
                            <!-- alerta por si no existen -->
                            <div class="row shadow" style="border-radius: 5px">
                                <div v-if="listas.response.listaGrupos.length === 0">
                                    <div class="alert alert-danger" role="alert" v-if="listas.response.listaGrupos.length === 0">
                                        <h2 class="lead">No se cuenta con grupos registradas</h2>
                                    </div>
                                </div>
                            </div>
                            <!-- fin de alerta -->
                            <!-- inicio tabla -->
                            <div class="float-left">
                                <b-button class="mb-1" variant="info" @click="showModal('my-modal')" v-b-tooltip.hover title="Agregar registro"><i class="material-icons">add_box</i></b-button>
                            </div>
                            <br>
                            <table v-show="listas.response.listaGrupos.length > 0" class="table table-hover table-light">
                                <thead>
                                    <tr style="background-color: #019979">
                                    <th scope="col" class="text-white lead">Número</th>
                                    <th scope="col" class="text-white lead">Letra</th>
                                    <th scope="col" class="text-white lead">Acciones</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="(grupo, index) in listas.response.listaGrupos" :key="index" class="table-light lead">
                                    <td>{{grupo.gradoGrupo}}</td>
                                    <td>{{grupo.letraGrupo}}</td>
                                    <td>
                                        <b-button variant="warning" style="margin-right:20px;" v-b-tooltip.hover title="Modificar información" id="show-btn" @click="showModal('modal-modificar'); llenarObjetoGrupo(grupo)"><i class="material-icons">create</i></b-button>
                                        <b-button variant="danger" id="show-btn" @click="eliminarGrupo(grupo.id)" v-b-tooltip.hover title="Eliminar registro"><i class="material-icons">delete</i></b-button>
                                    </td>
                                    </tr>
                                </tbody>
                            </table>
                            <!-- fin tabla-->
                        </div>
                        <div class="card-footer text-muted">
                        </div>
                    </div>
                </div>
                  <div class="col-md-6">
                    <div class="card text-center">
                        <div class="card-header">
                            <h4><strong>Asignación de Grupos a Carreras</strong></h4>
                        </div>
                        <div class="card-body">
                            <!-- alerta por si no existen -->
                            <div class="row shadow" style="border-radius: 5px">
                                <div v-if="asignaciones.length === 0">
                                    <div class="alert alert-danger" role="alert" v-if="asignaciones.length === 0">
                                        <h2 class="lead">No se cuenta con carreras registradas</h2>
                                    </div>
                                </div>
                            </div>
                            <!-- fin de alerta -->
                            <!-- inicio tabla -->
                            <div class="float-left">
                                <b-button class="mb-1" variant="info" @click="showModal('modal-asignar')" v-b-tooltip.hover title="Agregar registro"><i class="material-icons">add_box</i></b-button>
                            </div>
                            <br>
                            <table v-show="asignaciones.length > 0" class="table table-hover table-light">
                                <thead>
                                    <tr style="background-color: #019979">
                                    <!-- <th scope="col">#</th> -->
                                    <th scope="col" class="text-white lead">Grupo</th>
                                    <th scope="col" class="text-white lead">Carrera</th>
                                    <th scope="col" class="text-white lead">Acciones</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-for="(asignacion, index) in asignaciones" :key="index" class="table-light lead">
                                    <!-- <th scope="row">{{grupo.id}}</th> -->
                                    <td>{{asignacion.gradoGrupo}} {{asignacion.letraGrupo}}</td>
                                    <td>{{asignacion.nombreCarrera}}</td>
                                    <td>
                                        <b-button variant="warning" style="margin-right:20px;" id="show-btn" @click="showModal('modal-modificarA'); llenarObjAsignacion(asignacion)" v-b-tooltip.hover title="Modificar información"><i class="material-icons">create</i></b-button>
                                        <b-button variant="danger" id="show-btn" @click="eliminarAsignacion(asignacion.id)" v-b-tooltip.hover title="Eliminar registro"><i class="material-icons">delete</i></b-button>
                                    </td>
                                    </tr>
                                </tbody>
                            </table>
                            <!-- fin tabla-->
                        </div>
                        <div class="card-footer text-muted">
                        </div>
                    </div>
                </div>
            </div>
        </div> 
<!-- Modal modificar grupo-->
        <b-modal ref="modal-modificar" hide-footer title="Modificar Grupo">
            <div class="d-block text-left">
                <!-- <h3>Nuevo Grupo</h3> -->
                <form @submit="modificarGrupo">
                    <div class="form-group">
                    <label for="formGroupExampleInput">Número</label>
                    <input type="text" class="form-control"  placeholder="1" v-model="objGrupo.gradoGrupo" required>
                    </div>
                    <div class="form-group">
                    <label for="formGroupExampleInput2">Letra</label>
                    <input type="text" class="form-control"  placeholder="A" v-model="objGrupo.letraGrupo" required>
                    </div>
                    <b-button class="mt-3" type="submit" block variant="outline-success">Modificar</b-button>
                    <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificar')">Cerrar</b-button>
                </form>
            </div>
        </b-modal>

<!-- MODAL REGISTRAR GRUPO-->
        <b-modal ref="my-modal" hide-footer title="Nuevo Grupo">
            <div class="d-block text-left">
                <b-form @submit="registrarGrupo">
                    <div class="form-group">
                        <label for="formGroupExampleInput">Número</label>
                        <b-form-input type="text" class="form-control" v-model="gradoGrupo" :state="validation" required placeholder="Ingrese solo números" />
                        <b-form-invalid-feedback>
                            Ingrese al menos 1 número.
                        </b-form-invalid-feedback>
                    </div>
                    <div class="form-group">
                        <label for="formGroupExampleInput2">Letra</label>
                        <b-form-input type="text" class="form-control" v-model="letraGrupo" :state="valid" required placeholder="Ingrese solo letras"/>
                        <b-form-invalid-feedback>
                            Ingrese al menos 1 letra.
                        </b-form-invalid-feedback>
                    </div>
                    <b-button  type="submit" block variant="outline-success">Registrar</b-button>
                </b-form>
            </div>
            <b-button class="mt-3" variant="outline-danger" block @click="hideModal('my-modal')">Cerrar</b-button>
        </b-modal> 
<!-- MODAL ASIGNACIÓN -->
        <b-modal ref="modal-asignar" hide-footer title="Nueva Asignación">
                    <div class="d-block text-left">
                        <!-- <h3>Hello From My Modal!</h3> -->
                        <b-form @submit="registrarAsignacion">
                            <div class="row form-group">

                                <div class="col">
                                    <label for>Grupos</label>
                                    <b-form-select v-model="grupoId" class="form-control" required :state="grupoValid">
                                        <option
                                        v-for="grupo in listas.response.listaGrupos"
                                        :key="grupo.id"
                                        :value="grupo.id">
                                        {{grupo.gradoGrupo}}{{grupo.letraGrupo}}
                                        </option>
                                    </b-form-select>
                                </div>

                                <div class="col">
                                    <label for>Carreras</label>
                                    <b-form-select v-model="carreraId" class="form-control" required :state="carreraValid">
                                        <option
                                        v-for="carrera in listas.response.listaCarreras"
                                        :key="carrera.id"
                                        :value="carrera.id">
                                        {{carrera.nombreCarrera}}
                                        </option>
                                    </b-form-select>
                                </div>
                            </div>
                            <b-button  type="submit" block variant="outline-success">Asignar</b-button>
                        </b-form>
                    </div>
                    <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-asignar')">Cerrar</b-button>
            </b-modal>
<!-- MODIFICAR ASIGNACIÓN -->
            <b-modal ref="modal-modificarA" hide-footer title="Modificar Asignación">
                <div class="d-block text-center">
                    <form @submit="modificarAsignacion">
                            <div class="row form-group">
                                <div class="col">
                                <label for>Grupo</label>
                                <select v-model="grupoModificarId" class="form-control" required>
                                    <option
                                    v-for="grupo in listas.response.listaGrupos"
                                    :key="grupo.id"
                                    :value="grupo.id">
                                    {{grupo.gradoGrupo}}{{grupo.letraGrupo}}
                                    </option>
                                </select>
                                </div>
                                <div class="col">
                                <label for>Carrera</label>
                                <select v-model="carreraModificarId" class="form-control" required>
                                    <option
                                    v-for="carrera in listas.response.listaCarreras"
                                    :key="carrera.id"
                                    :value="carrera.id">
                                    {{carrera.nombreCarrera}}
                                    </option>
                                </select>
                                </div>
                            </div>
                            <b-button  type="submit" block variant="outline-success">Modificar</b-button>
                        </form>
                    <b-button class="mt-3" variant="outline-danger" block @click="hideModal('modal-modificarA')">Cancelar</b-button>
                </div>
            </b-modal>
        </section>
</template>

<script>
import axios from 'axios'
import {server} from '../../store'
import { functions } from '../../functionsGolbals'

export default {
    mixins: [functions], 
    data(){
        return{
            user:[],
            currentObj: null,
            output:null,
            grupoId: '',
            carreraId: '',
            listas:[],
            objGrupo:[],
            asignaciones:[],
            letraGrupo: '',
            gradoGrupo: '',
            objAsignacon:[],
            grupoModificarId:null,
            carreraModificarId:null
        }
    },
    computed:{
        validation(){
            if(this.gradoGrupo == '')return null;
            if(this.gradoGrupo.length > 0) return true;
            else return false;  
        },
        valid(){
            if(this.letraGrupo == '')return null;
            if(this.letraGrupo.length > 0)return true;
            else return false;
        },
        grupoValid(){
            if(this.grupoId == 0) return null;
            return true;
        },
        carreraValid(){
            if(this.carreraId == 0)return null;
            else return true;
        }
    },
    mounted(){
        if(localStorage.getItem('usuario') == null){
          this.$router.push("/login");
        }else{
          this.user = JSON.parse(localStorage.getItem('usuario'));
        }
        this.obtenerListas();
        this.obtenerAsignaciones();
    },
    methods:{
         llenarObjAsignacion: function (asignacion) {
            this.objAsignacon = asignacion
        },
        obtenerListas(){
            axios
                .get(`${server.baseURL}/api/grupo-carrera/listasParaRegistro`)
                .then(data => (this.listas = data.data));
        },
        obtenerAsignaciones(){
            axios
                .get(`${server.baseURL}/api/grupo-carrera/lista`)
                .then(data => (this.asignaciones = data.data));
        },
        llenarObjetoGrupo: function (grupo) {
            this.objGrupo = grupo;
        },
        registrarGrupo(e) {
        e.preventDefault();
        let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo/registrar`, {
                grupo:{
                    gradoGrupo: this.gradoGrupo,
                    letraGrupo: this.letraGrupo,
                }
            })
            .then(function (response) {
                currentObj.output = response.data;
                currentObj.obtenerListas();
                currentObj.hideModal('my-modal');
                currentObj.alertSuccess(currentObj.output.response.message);  
            })
            .catch(function (error) {
                currentObj.output = error;
                currentObj.hideModal('my-modal');  
               currentObj.alertError(currentObj.output.response.message);
            });
        },
        modificarGrupo(e) {
        e.preventDefault();
        let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo/modificacion`, {
                grupo:{
                    id: this.objGrupo.id,
                    gradoGrupo: this.objGrupo.gradoGrupo,
                    letraGrupo: this.objGrupo.letraGrupo,
                    status: 1
                }
            })
            .then(function (response) {
                currentObj.output = response.data;
                currentObj.obtenerListas();
                currentObj.obtenerAsignaciones();
                currentObj.hideModal('modal-modificar');
                currentObj.alertSuccess(currentObj.output.response.message);    
            })
            .catch(function (error) {
                currentObj.output = error;
                currentObj.hideModal('modal-modificar');  
               currentObj.alertError(currentObj.output.response.message);    

            });
        },
        registrarAsignacion(e) {
        e.preventDefault();
        let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-carrera/registro`, {
                registro:{
                    idGrupo: this.grupoId,
                    idCarrera: this.carreraId,
                }
            })
            .then(function (response) {
                currentObj.output = response.data;
                currentObj.obtenerAsignaciones();
                currentObj.hideModal('modal-asignar');
                currentObj.alertSuccess(currentObj.output.response.message);  
            })
            .catch(function (error) {
                currentObj.output = error;
                currentObj.obtenerAsignaciones();
                currentObj.hideModal('modal-asignar');  
               currentObj.alertError(currentObj.output.response.message);
            });
        },
        modificarAsignacion(e) {
            e.preventDefault();
            let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-carrera/modificar`, {
                    modificar: {
                        idGrupo: this.grupoModificarId,
                        idCarrera: this.carreraModificarId,
                        id: this.objAsignacon.id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificarA');
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.obtenerAsignaciones();
                    currentObj.hideModal('modal-modificarA');
                   currentObj.alertError(currentObj.output.response.message);
                });
        },
        eliminarGrupo(id){
          let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo/eliminacion`, {
                    grupo: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerListas();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
        eliminarAsignacion(id){
          let currentObj = this;
            axios.post(`${server.baseURL}/api/grupo-carrera/eliminar`, {
                    grupoCarrera: {
                        id: id
                    }
                })
                .then(function (response) {
                    currentObj.output = response.data;
                    currentObj.obtenerAsignaciones();
                    currentObj.alertSuccess(currentObj.output.response.message);
                })
                .catch(function (error) {
                    currentObj.output = error;
                    currentObj.alertError(currentObj.output.response.message);
                });
        },
    }
}
</script>